 boolean showVertexIds=false, showVertices=false;
 boolean showFrames=false, showKeys=true, animate=true,  showConstruction=false,
   showLinear=false, showCubic=true, showMid=true, showSpiral=true, expo=false, fit=false, showBezier=false, showCatmull=false,  fourPoint=true;
float tt=0;
 void myActions() { // actions to be executed at each frame
   background(white); // clear screen
   if(loadedI) image(I, 0, 0); // show loaded image
   if ((mousePressed)&&(!keyPressed)) {scribe(); editPolygon();} // edit points
    if ((mousePressed)&&(mouse().isInWindow())&&(keyPressed)) {
         if (key=='z') scaleBy(1.- d(screenCenter(),Mouse()) / d(screenCenter(),Pmouse()) );
         if (key=='r') rotateBy( angle( V(screenCenter(),Mouse()) , V(screenCenter(),Pmouse()) ) );
         if (key=='t') translateBy(MouseDrag());
         if (key=='a') twistPoint();
         }
//    stroke(skin); showTwists(30);
    EDGE A=E(P[0],P[1],twist[0],twist[1]);  
    EDGE B=E(P[2],P[3],twist[2],twist[3]);  
    EDGE C=E(P[4],P[5],twist[4],twist[5]);  
    EDGE D=E(P[6],P[7],twist[6],twist[7]);
     
    strokeWeight(4); 
    if(showFrames) { 
       if(fourPoint) {stroke(grey); showFourPointFrames(A,B,C,D,1);};
       for(float t=0; t<=1.0; t+=1.0/16/3) showAll(A,B,C,D,t);
       };
    if(animate) {strokeWeight(5); 
       if(fourPoint) {stroke(grey); showFourPointFrame();};
       tt+=1./193; if(tt>1) tt=0; showAll(A,B,C,D,tt); 
       };
    scribe("File: P"+Format0(fn,2)+" out of "+Format0(maxfn,2)+". Toggles: l, v, m, s, e, b, i, c, f"); 
    pushMatrix();
    if (showLinear) {translate(0,20); scribe(dgreen,"Linear vertex paths (l)");} 
    if (showCubic) {translate(0,20); scribe(cyan,"Vertex-interpolating cubic paths (v)");}
    if (showMid) {translate(0,20); scribe(blue,"Midpoint-interpolating cubic path (m)");} 
    if (showSpiral) {translate(0,20); scribe(red,"Steady spirals (s)");} 
    if (expo) {translate(0,20); scribe(dred,"Equitempered spirals (e)");}
    if (showBezier) {translate(0,20); scribe(dyellow,"Bezier of spirals (b)");} 
    if (fit) {translate(0,20); scribe(magenta,"Interpolating bezier of spirals (i)"); }   
    if (showCatmull) {translate(0,20); scribe(orange,"Catmull of spirals (c)");} 
    if (fourPoint) {translate(0,20); scribe(grey,"Four-point subdivision of spirals (f)"); }   
    popMatrix(); 
    strokeWeight(4); if (showKeys) {stroke(black); A.show(); B.show(); C.show(); D.show(); 
    fill(black); A.A.showLabel("A"); B.A.showLabel("B"); C.A.showLabel("C"); D.A.showLabel("D"); noFill();
//                 A.showTangents(30); B.showTangents(30); C.showTangents(30); D.showTangents(30);
//                 stroke(grey);A.drawCurve(); B.drawCurve(); C.drawCurve(); D.drawCurve();
               };
    if(fit&showConstruction) {
      expoTemp=false;
      strokeWeight(4);  stroke(dcyan); 
      EDGE L=retrofitBezier(A,B,C,D); L.show(); L.A.showLabel("B'"); 
      L=retrofitBezier1(A,B,C,D); L.show(); L.A.showLabel("Ldc"); 
      L=retrofitBezier2(A,B,C,D); L.show(); L.A.showLabel("Lab"); 
      stroke(green); 
      EDGE R=retrofitBezier(D,C,B,A); R.show(); R.A.showLabel("C'");
      R=retrofitBezier1(D,C,B,A); R.show(); R.A.showLabel("Rab");
      R=retrofitBezier2(D,C,B,A); R.show(); R.A.showLabel("Rdc");
      strokeWeight(1);
      };
   };
  
void showAll(EDGE A, EDGE B, EDGE C, EDGE D, float t) {
  if(showLinear) {stroke(dgreen); if(t<1./3) S(A,t*3,B).show(); else {if(t<2./3) S(B,(t-1./3)*3,C).show(); else  S(C,(t-2./3)*3,D).show();}; };
  if(showCubic) {stroke(cyan); cubic(A,B,C,D,t).show();};  // retrofic cubic to end-points
  if(showMid) {stroke(blue); retrofitMSR(A,B,C,D,t).show(); }; 
  if(showSpiral) {expoTemp=false; stroke(red); if(t<1./3) R(A,t*3,B).show(); else {if(t<2./3) R(B,(t-1./3)*3,C).show(); else  R(C,(t-2./3)*3,D).show();};};
  if(expo) {expoTemp=true; stroke(dred); if(t<1./3) R(A,t*3,B).show(); else {if(t<2./3) R(B,(t-1./3)*3,C).show(); else  R(C,(t-2./3)*3,D).show();}; expoTemp=false; };
  if(showBezier) {stroke(dyellow); bezier(A,B,C,D,t).show();};
  if(showCatmull) {stroke(orange); if(t<1./3) catmull(A,A,B,C,t*3).show(); else {if(t<2./3) catmull(A,B,C,D,(t-1./3)*3).show(); else  catmull(B,C,D,D,(t-2./3)*3).show();}; 
                   if(showConstruction) showCatmullConstruction(A,B,C,D);};
  if(fit) {stroke(magenta); expoTemp=false; retrofitSpiral(A,B,C,D,t).show(); }
  }

void showCatmullConstruction(EDGE A, EDGE B, EDGE C, EDGE D) {stroke(magenta); R(A,1./6,C,B).show(); R(D,1./6,B,C).show(); stroke(blue);};
 
void showFourPointFrame() {FPA[FPAi++].show(); if(FPAi>=FPAn) FPAi=0;}

void FourPointAnimationInit() {FourPointAnimationInit(E(P[0],P[1],twist[0],twist[1]),E(P[2],P[3],twist[2],twist[3]),E(P[4],P[5],twist[4],twist[5]),E(P[6],P[7],twist[6],twist[7]));}  

void FourPointAnimationInit(EDGE A, EDGE B, EDGE C, EDGE D) {
  FourPointSpiralInit(A,B,C,D);
  for(int i=0; i<FPAr; i++) FourPointSpiralSubdivde();
  for(int i=0; i<FPn; i++) FPA[i]=E(FP[i]); 
  FPAn=FPn;
  }
  
void showFourPointFrames(EDGE A, EDGE B, EDGE C, EDGE D, int r) {
  FourPointSpiralInit(A,B,C,D);
  for(int i=0; i<FPr; i++) FourPointSpiralSubdivde();
  FourPointSpiralShowFrames();
  }

int FPr=4, FPAr=6; // levels of subdivision for showing frames and animation
int FPn=4, FPAn=4; // initial length of the FP array (4 edges)
int FPAi=0; // Four point animation conter
EDGE[] FP = new EDGE[193]; // SUBDIVIDED EDGE LIST 4+3*(1+2+4+8+16+32)
EDGE[] FPA = new EDGE[193]; // SUBDIVIDED EDGE LIST 4+3*(1+2+4+8+16+32)

void FourPointSpiralInit(EDGE A, EDGE B, EDGE C, EDGE D) {FP[0]=E(A); FP[1]=E(B); FP[2]=E(C); FP[3]=E(D); FPn=4;}; // reload FP

void FourPointSpiralSubdivde() {
    EDGE[] L = new EDGE[2*FPn-1]; 
    for(int i=0; i<FPn; i++) {L[2*i]=E(FP[i]);if(i<FPn-1)  L[2*i+1]=FPmid(FPf(i-1),FPf(i),FPf(i+1),FPf(i+2));}
    FPn=2*FPn-1;
    for(int i=0; i<FPn; i++) FP[i]=E(L[i]); 
    }
EDGE FPf(int i) {if(i==-1) return R(FP[1],2,FP[0]); if(i==FPn) return R(FP[FPn-2],2,FP[FPn-1]); return FP[i]; }

void FourPointSpiralShowFrames()  {for(int i=0; i<FPn; i++) FP[i].show();}; 
    
EDGE FPmid(EDGE A, EDGE B, EDGE C, EDGE D) {return R(R(A,1.125,B),0.5,R(D,1.125,C));} 

